$fn = 21;
m4_screw_radius = 4.826/2;
m4_hole_radius = m4_screw_radius * 1.20; 

rail_width = 20;
rail_slot_width = 5.05;
rail_slot_depth = 1.33;

thickness = 1.2;

//m4 washer for 2020 rail
rounding_radius = 3;

wall_thickness = 1.8;
wire_hole_radius = (rail_width - 4)/2;

frame_margin = 2.3;

cube([rounding_radius, rail_width - 1, thickness + 1]);

washer_addl_thickness = 3.95;
washer_r0 = m4_hole_radius + 2;
washer_r1 = m4_hole_radius + 3;


translate([0,0,thickness + 1]){
  difference(){
    cube([wall_thickness, rail_width -1, rail_width -1]);
    translate([-1,frame_margin + rounding_radius,frame_margin + rounding_radius]){
      minkowski(){
        cube([wall_thickness * 2, rail_width - 1- frame_margin * 2 - rounding_radius *2, rail_width -1 - frame_margin *2 - rounding_radius * 2]);
        rotate([0,90,0]){
          cylinder(r = rounding_radius, h = 1);
        }
      }
    }
  }
  
  translate([wall_thickness,0,0]){
    rotate([0,-90,-90]){
      linear_extrude(height = wall_thickness - 0.2){
        polygon([
        [0,0],
        [0,(rail_width - 1)/2],
        [(rail_width -1)*(13/14),0]
        ]);
      }
    }
  }
}
  
difference(){
  union(){
    translate([rounding_radius, rounding_radius,0]){
      minkowski(){
        cube([(rail_width - rounding_radius *2 - 1),(rail_width - rounding_radius *2 - 1), thickness]);
        cylinder(r = rounding_radius, h = 1);
      }
    }
    translate([0,(rail_width - 1 - rail_slot_width)/2,-1 * rail_slot_depth]){
      cube([rail_width -1, rail_slot_width - 0.133, rail_slot_depth]);
    }
      
    translate([(rail_width - 1)/2,(rail_width - 1)/2 ,thickness]){
      cylinder(r2=washer_r0, r1 = washer_r1, h = washer_addl_thickness, $fn = 15);
    }
  

  }

  translate([(rail_width - 1)/2,(rail_width - 1)/2,-3*thickness]){    
      cylinder(r = m4_hole_radius , h = thickness * 9);
  }  
}

